Subject: Re: bug#71823: 31.0.50; project-mode-line and eglot duplicate project-name in mode-line

From: João Távora <[email-masked]>
Date: Sun, 30 Jun 2024 15:53:39 +0100

On Sun, Jun 30, 2024, 13:51 <[email-masked]> wrote:

> João Távora <[email-masked]> writes:
> > On Sat, Jun 29, 2024, 15:24 Spencer Baugh <[email-masked]> wrote:
> >
> >  Or, here's an alternative idea, more aggressive:
> >
> >  What if Eglot just sets project-mode-line=t in eglot-managed buffers,
> and removes the project-name from the Eglot entry
> >  entirely?
> >
> >  Then the language identifier would be the major mode, the project
> identifier would be project-mode-line, and the eglot status
> >  indicator would just be for the status of the server.
> >
> > Works for me, it's in line with Eglot's policy of setting other modes
> when managing buffers. Show a patch.
>
> Attached.
>
> I do think this is a great way to resolve this - now that
> project-mode-line exists, using it deletes one small bit of
> eglot-specific functionality, which is in line with the Eglot design
> philosophy.
>

Yes.

The only issue is that this was only added to mode-line-format in Emacs
> 30, so we can only use it in Emacs 30 or later.
>

No, that's not an issue, or rather your solution isn't the way to solve it.
In trunk Eglot use everything that is in trunk Emacs. In released Eglot
versions name sure you depend on capable versions of core GNU Elpa
packages, a set which already includes project.el. So basically version
bumps solves it.

So please show an updated patch, and don't forget the etc/EGLOT-NEWS entry.

> But also, my idea of eglot-mode-line-format should be alsoh considered.
> AFAICT there no big technical hurdle, it's just relatively
> > boring work and some naming decisions to make. And as I mentioned, it
> would fix more issues than just the one at hand.
>
> Yes, I think that would also be useful as a separate patch.
>

Looking forward to it.

João